/* SystemBackground.c generated by valac 0.46.10, the Vala compiler
 * generated from SystemBackground.vala, do not modify */

/*
 * Copyright 2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authors: Corentin Noël <corentin@elementary.io>
 */

#include <meta/meta-background-actor.h>
#include <glib-object.h>
#include <meta/meta-background.h>
#include <glib.h>
#include <clutter/clutter.h>
#include <meta/screen.h>
#include <gio/gio.h>
#include <gsettings-desktop-schemas/gdesktop-enums.h>

#define GREETER_TYPE_SYSTEM_BACKGROUND (greeter_system_background_get_type ())
#define GREETER_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_TYPE_SYSTEM_BACKGROUND, GreeterSystemBackground))
#define GREETER_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_TYPE_SYSTEM_BACKGROUND, GreeterSystemBackgroundClass))
#define GREETER_IS_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_TYPE_SYSTEM_BACKGROUND))
#define GREETER_IS_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_TYPE_SYSTEM_BACKGROUND))
#define GREETER_SYSTEM_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_TYPE_SYSTEM_BACKGROUND, GreeterSystemBackgroundClass))

typedef struct _GreeterSystemBackground GreeterSystemBackground;
typedef struct _GreeterSystemBackgroundClass GreeterSystemBackgroundClass;
typedef struct _GreeterSystemBackgroundPrivate GreeterSystemBackgroundPrivate;
enum  {
	GREETER_SYSTEM_BACKGROUND_0_PROPERTY,
	GREETER_SYSTEM_BACKGROUND_NUM_PROPERTIES
};
static GParamSpec* greeter_system_background_properties[GREETER_SYSTEM_BACKGROUND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GREETER_SYSTEM_BACKGROUND_LOADED_SIGNAL,
	GREETER_SYSTEM_BACKGROUND_NUM_SIGNALS
};
static guint greeter_system_background_signals[GREETER_SYSTEM_BACKGROUND_NUM_SIGNALS] = {0};

struct _GreeterSystemBackground {
	MetaBackgroundActor parent_instance;
	GreeterSystemBackgroundPrivate * priv;
};

struct _GreeterSystemBackgroundClass {
	MetaBackgroundActorClass parent_class;
};

static gpointer greeter_system_background_parent_class = NULL;
static MetaBackground* greeter_system_background_system_background;
static MetaBackground* greeter_system_background_system_background = NULL;

GType greeter_system_background_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterSystemBackground, g_object_unref)
GreeterSystemBackground* greeter_system_background_new (MetaScreen* screen);
GreeterSystemBackground* greeter_system_background_construct (GType object_type,
                                                              MetaScreen* screen);
void greeter_system_background_refresh (GreeterSystemBackground* self);
static GObject * greeter_system_background_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void greeter_system_background_finalize (GObject * obj);

static const ClutterColor GREETER_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR = {(guint8) 0x2e, (guint8) 0x34, (guint8) 0x36, (guint8) 0xff};

GreeterSystemBackground*
greeter_system_background_construct (GType object_type,
                                     MetaScreen* screen)
{
	GreeterSystemBackground * self = NULL;
	g_return_val_if_fail (screen != NULL, NULL);
	self = (GreeterSystemBackground*) g_object_new (object_type, "meta-screen", screen, "monitor", 0, NULL);
	return self;
}

GreeterSystemBackground*
greeter_system_background_new (MetaScreen* screen)
{
	return greeter_system_background_construct (GREETER_TYPE_SYSTEM_BACKGROUND, screen);
}

void
greeter_system_background_refresh (GreeterSystemBackground* self)
{
	MetaBackground* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = greeter_system_background_system_background;
	if (_tmp0_ != NULL) {
		MetaBackground* _tmp1_;
		_tmp1_ = greeter_system_background_system_background;
		meta_background_set_color (_tmp1_, &GREETER_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR);
	}
}

static GObject *
greeter_system_background_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GreeterSystemBackground * self;
	MetaBackground* _tmp0_;
	MetaBackground* _tmp9_;
	parent_class = G_OBJECT_CLASS (greeter_system_background_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_SYSTEM_BACKGROUND, GreeterSystemBackground);
	_tmp0_ = greeter_system_background_system_background;
	if (_tmp0_ == NULL) {
		MetaScreen* _tmp1_;
		MetaScreen* _tmp2_;
		MetaScreen* _tmp3_;
		MetaBackground* _tmp4_;
		GFile* texture_file = NULL;
		GFile* _tmp5_;
		MetaBackground* _tmp6_;
		MetaBackground* _tmp7_;
		GFile* _tmp8_;
		g_object_get ((MetaBackgroundActor*) self, "meta-screen", &_tmp1_, NULL);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = meta_background_new (_tmp3_);
		_g_object_unref0 (greeter_system_background_system_background);
		greeter_system_background_system_background = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_tmp5_ = g_file_new_for_uri ("resource:///io/elementary/desktop/gala/texture.png");
		texture_file = _tmp5_;
		_tmp6_ = greeter_system_background_system_background;
		meta_background_set_color (_tmp6_, &GREETER_SYSTEM_BACKGROUND_DEFAULT_BACKGROUND_COLOR);
		_tmp7_ = greeter_system_background_system_background;
		_tmp8_ = texture_file;
		meta_background_set_file (_tmp7_, _tmp8_, G_DESKTOP_BACKGROUND_STYLE_WALLPAPER);
		_g_object_unref0 (texture_file);
	}
	_tmp9_ = greeter_system_background_system_background;
	g_object_set ((MetaBackgroundActor*) self, "background", _tmp9_, NULL);
	return obj;
}

static void
greeter_system_background_class_init (GreeterSystemBackgroundClass * klass,
                                      gpointer klass_data)
{
	greeter_system_background_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = greeter_system_background_constructor;
	G_OBJECT_CLASS (klass)->finalize = greeter_system_background_finalize;
	greeter_system_background_signals[GREETER_SYSTEM_BACKGROUND_LOADED_SIGNAL] = g_signal_new ("loaded", GREETER_TYPE_SYSTEM_BACKGROUND, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
greeter_system_background_instance_init (GreeterSystemBackground * self,
                                         gpointer klass)
{
}

static void
greeter_system_background_finalize (GObject * obj)
{
	GreeterSystemBackground * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GREETER_TYPE_SYSTEM_BACKGROUND, GreeterSystemBackground);
	G_OBJECT_CLASS (greeter_system_background_parent_class)->finalize (obj);
}

GType
greeter_system_background_get_type (void)
{
	static volatile gsize greeter_system_background_type_id__volatile = 0;
	if (g_once_init_enter (&greeter_system_background_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GreeterSystemBackgroundClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_system_background_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterSystemBackground), 0, (GInstanceInitFunc) greeter_system_background_instance_init, NULL };
		GType greeter_system_background_type_id;
		greeter_system_background_type_id = g_type_register_static (meta_background_actor_get_type (), "GreeterSystemBackground", &g_define_type_info, 0);
		g_once_init_leave (&greeter_system_background_type_id__volatile, greeter_system_background_type_id);
	}
	return greeter_system_background_type_id__volatile;
}

